cgroup	GROUP	code_seg, data_seg
	ASSUME	cs:cgroup, ds:cgroup
code_seg SEGMENT PUBLIC
; 頥 ॠ  
;  ᥢ
	PUBLIC	mov_to_hex_position
	EXTRN	goto_xy:NEAR
data_seg SEGMENT PUBLIC
	EXTRN	lines_before_sector:BYTE
data_seg ENDS
mov_to_hex_position PROC NEAR
	push	ax
	push	cx
	push	dx
	mov	dh,lines_before_sector
	add	dh,2
	add	dh,phantom_cursor_y
	mov	dl,8
	mov	cl,3
	mov	al,phantom_cursor_x
	mul	cl
	add	dl,al
	call	goto_xy
	pop	dx
	pop	cx
	pop	ax
	ret
mov_to_hex_position ENDP
;
; 頥 ॠ   砫
; ᥢ   ASCII
	PUBLIC	mov_to_ascii_position
	EXTRN	goto_xy:NEAR
data_seg SEGMENT PUBLIC
	EXTRN	lines_before_sector:BYTE
data_seg ENDS
mov_to_ascii_position PROC NEAR
	push	ax
	push	dx
	mov	dh,lines_before_sector
	add	dh,2
	add	dh,phantom_cursor_y
	mov	dl,59
	add	dl,phantom_cursor_x
	call	goto_xy
	pop	dx
	pop	ax
	ret
mov_to_ascii_position ENDP
;
;  樨 ॠ쭮 
	PUBLIC	save_real_cursor
save_real_cursor PROC NEAR
	push	ax
	push	bx
	push	cx
	push	dx
	mov	ah,3
	xor	bh,bh
	int	10h
	mov	real_cursor_y,dl
	mov	real_cursor_x,dh
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
save_real_cursor ENDP
;
; ⠭ ॠ쭮 
	PUBLIC	restore_real_cursor
	EXTRN	goto_xy:NEAR
restore_real_cursor PROC NEAR
	push	dx
	mov	dl,real_cursor_y
	mov	dh,real_cursor_x
	call	goto_xy
	pop	dx
	ret
restore_real_cursor ENDP
;
;  ᥢ
	PUBLIC	write_phantom
	EXTRN	write_attribute_n_times:NEAR
write_phantom PROC NEAR
	push	cx
	push	dx
	call	save_real_cursor
	call	mov_to_hex_position
	mov	cx,4
	mov	dl,1eh
	call	write_attribute_n_times
	call	mov_to_ascii_position
	mov	cx,1
	mov	dl,4eh
	call	write_attribute_n_times
	call	restore_real_cursor
	pop	dx
	pop	cx
	ret
write_phantom ENDP
;
; ࠭ ᥢ
	PUBLIC	erase_phantom
	EXTRN	write_attribute_n_times:NEAR
erase_phantom PROC NEAR
	push	cx
	push	dx
	call	save_real_cursor
	call	mov_to_hex_position
	mov	cx,4
	mov	dl,7
	call	write_attribute_n_times
	call	mov_to_ascii_position
	mov	cx,1
	call	write_attribute_n_times
	call	restore_real_cursor
	pop	dx
	pop	cx
	ret
erase_phantom ENDP
;
; 騥 4 楤 ६ ᥢ
	PUBLIC	phantom_up
phantom_up PROC NEAR
	call	erase_phantom
	dec	phantom_cursor_y
	jns	wasnt_at_top
	call	scroll_down
wasnt_at_top:
	call	write_phantom
	ret
phantom_up ENDP
	PUBLIC	phantom_down
phantom_down PROC NEAR
	call	erase_phantom
	inc	phantom_cursor_y
	cmp	phantom_cursor_y,16
	jb	wasnt_at_bottom
	call	scroll_up
wasnt_at_bottom:
	call	write_phantom
	ret
phantom_down ENDP
	PUBLIC	phantom_left
phantom_left PROC NEAR
	call	erase_phantom
	dec	phantom_cursor_x
	jns	wasnt_at_left
	mov	phantom_cursor_x,0
wasnt_at_left:
	call	write_phantom
	ret
phantom_left ENDP
	PUBLIC	phantom_right
phantom_right PROC NEAR
	call	erase_phantom
	inc	phantom_cursor_x
	cmp	phantom_cursor_x,16
	jb	wasnt_at_right
	mov	phantom_cursor_x,15
wasnt_at_right:
	call	write_phantom
	ret
phantom_right ENDP
	EXTRN	disp_half_sector:NEAR
	EXTRN	goto_xy:NEAR
data_seg SEGMENT PUBLIC
	EXTRN	sector_offset:WORD
	EXTRN	lines_before_sector:BYTE
data_seg ENDS
;
; 騥 2 楤
; 뢠   ᥪ
scroll_up PROC NEAR
	push	dx
	call	erase_phantom
	call	save_real_cursor
	xor	dl,dl
	mov	dh,lines_before_sector
	add	dh,2
	call	goto_xy
	mov	dx,256
	mov	sector_offset,dx
	call	disp_half_sector
	call	restore_real_cursor
	mov	phantom_cursor_y,0
	call	write_phantom
	pop	dx
	ret
scroll_up ENDP
scroll_down PROC NEAR
	push	dx
	call	erase_phantom
	call	save_real_cursor
	xor	dl,dl
	mov	dh,lines_before_sector
	add	dh,2
	call	goto_xy
	xor	dx,dx
	mov	sector_offset,dx
	call	disp_half_sector
	call	restore_real_cursor
	mov	phantom_cursor_y,15
	call	write_phantom
	pop	dx
	ret
scroll_down ENDP
code_seg ENDS
data_seg SEGMENT PUBLIC
real_cursor_x	DB	0
real_cursor_y	DB	0
	PUBLIC	phantom_cursor_x
	PUBLIC	phantom_cursor_y
phantom_cursor_x DB	0
phantom_cursor_y DB	0
data_seg ENDS
	END